set linesize 32000
set pagesize 1000
set head on
set echo on
set termout on
set trimspool on

spool constantplans.log

-- example data from blog post:
-- https://www.bobbydurrettdba.com/2012/08/03/outer-join-where-do-i-put-the/

drop table a;
drop table b;

create table a (x number);
create table b (x number);

insert into a values (1);
insert into a values (2);

insert into b values (1);
insert into b values (3);

commit;

execute dbms_stats.gather_table_stats(NULL,'A');
execute dbms_stats.gather_table_stats(NULL,'B');

select * from a;

select * from b;

-- outer join with condition that is part of outer join

select a.x,b.x
from a,b
where a.x(+)=b.x
and a.x(+)=2;

select * from table(dbms_xplan.display_cursor(null,null,'ALL'));

-- outer join with condition that isn't part of outer join

select a.x,b.x
from a,b
where a.x(+)=b.x
and a.x=2;

select * from table(dbms_xplan.display_cursor(null,null,'ALL'));

spool off

